#include <NewPing.h>
 
#define SONAR_NUM    4
#define MAX_DISTANCE 200
#define PING_INTERVAL 33
 
unsigned long pingTimer[SONAR_NUM]; 
unsigned int cm[SONAR_NUM];         
uint8_t currentSensor = 0;          
 
NewPing sonar[SONAR_NUM] = {    
  NewPing(A0, A1, MAX_DISTANCE),
  NewPing(4, 2, MAX_DISTANCE),
  NewPing(8, 9, MAX_DISTANCE),
  NewPing(5, 3, MAX_DISTANCE)
};
 
void setup() {
  Serial.begin(115200);
  pingTimer[0] = millis() + 75;  
  for (uint8_t i = 1; i < SONAR_NUM; i++)
    pingTimer[i] = pingTimer[i - 1] + PING_INTERVAL;
}
 
void loop() {
  for (uint8_t i = 0; i < SONAR_NUM; i++) {
    if (millis() >= pingTimer[i]) {        
      pingTimer[i] += PING_INTERVAL * SONAR_NUM;  
      if (i == 0 && currentSensor == SONAR_NUM - 1) oneSensorCycle();
      sonar[currentSensor].timer_stop();          
      currentSensor = i;                          
      cm[currentSensor] = 0;                      
      sonar[currentSensor].ping_timer(echoCheck); 
    }
  }
}
 
void echoCheck() {
  if (sonar[currentSensor].check_timer())
    cm[currentSensor] = sonar[currentSensor].ping_result / US_ROUNDTRIP_CM;
}
 
void oneSensorCycle() {
  for (uint8_t i = 0; i < SONAR_NUM; i++) {
    Serial.print(i);
    Serial.print(". sensor");
    Serial.print(" = ");
    Serial.print(cm[i]);
    Serial.print("cm \t");
  }
  Serial.println();
}
